function [_n,_stiva]=inserare_element(n,stiva)
	_n = n;
        _stiva = stiva;

	labels=['Valoare';'Eroare relativa'];
	[ok,val,err_rel]=getvalue('Inserare element',labels,...
      		list('vec',1,'vec',1),['';'']);
	if ok == %T then
		S = val - err_rel*val;
		D = val + err_rel*val;
		if S < D
			limS = S;
			limD = D;
		else
			limS = D;
			limD = S;
		end
		_n = _n + 1;
		if _n==1 then
			_stiva = [_n val err_rel limS limD];
		else
			_stiva = [_stiva;[_n val err_rel limS limD]];
		end;
		reset_view(_n,_stiva);
	end;
endfunction

function [_n,_stiva]=stergere_element(n,stiva)
	_n = n;
	_stiva = stiva;
	if _n > 0 then
		_n = _n-1;
		_stiva = _stiva(1:_n,:);
		reset_view(_n,stiva);
	else
		x_message(['Stiva este goala!!!'],['Ok']);
	end;
endfunction

function [_n,_stiva]=repeta_varf(n,stiva)
	_n = n;
        _stiva = stiva;
	if _n > 0 then
                _stiva = [_stiva;_stiva(_n,:)];
		_n = _n + 1;
		_stiva(_n,1) = _n;
                reset_view(_n,_stiva);
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
endfunction

function [_n,_stiva]=opus(n,stiva)
	_n = n;
        _stiva = stiva;
	if _n > 0 then
                _stiva(_n,2) = -_stiva(_n,2);
                reset_view(_n,_stiva);
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
endfunction

function [_n,_stiva]=invers(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 0 then
		if _stiva(_n,2) ~= 0 then
                	_stiva(_n,2) = 1/_stiva(_n,2);
	                reset_view(_n,_stiva);
		else
			x_message(['Ultima valoare nula!!!'],['Ok']);
		end;
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
endfunction

function [_n,_stiva]=radical(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 0 then
                if _stiva(_n,2)>=0
			val = sqrt(_stiva(_n,2));
			err_rel = _stiva(_n,3)/2;
			_stiva(_n,2) = val;
	       	         _stiva(_n,3) = err_rel;
			S = val - err_rel*val;
	                D = val + err_rel*val;
			if S < D
				_stiva(_n,4) = S;
				_stiva(_n,5) = D;
			else
				_stiva(_n,4) = D;
				_stiva(_n,5) = S;
			end
       		        reset_view(_n,_stiva);
		else
			x_message(['Valoarea este negativa!!!'],['Ok']);	
		end;
        else
                x_message(['Stiva este goala!!!'],['Ok']);
        end;
endfunction

function [_n,_stiva]=adunare(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
                val = _stiva(_n-1,2)+_stiva(_n,2);
		if val ~= 0
			err_rel = (abs(_stiva(_n-1,2))*_stiva(_n-1,3) + ...
		        abs(_stiva(_n,2))*_stiva(_n,3))/abs(val);
	                _stiva(_n-1,2) = val;
			_stiva(_n-1,3) = err_rel;
		        S = val - err_rel*val;
			D = val + err_rel*val;
			if S < D
			       _stiva(_n-1,4) = S;
			       _stiva(_n-1,5) = D;
			else
			       _stiva(_n-1,4) = D;
			       _stiva(_n-1,5) = S;
			end
			_n = _n -1;
			_stiva=_stiva(1:_n,:);
       		        reset_view(_n,_stiva);
		else
			x_message(['warning: x1+x2 = 0. Formula erorii';'la adunare nu se poate aplica'],['Ok']);
		end
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
endfunction
 
function [_n,_stiva]=scadere(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
		val = _stiva(_n-1,2)-_stiva(_n,2);
		if (abs(val) ~= 0)
                	err_rel = (abs(_stiva(_n-1,2))*_stiva(_n-1,3) + ...
                           abs(_stiva(_n,2))*_stiva(_n,3))/abs(val);
	                _stiva(_n-1,2) = val;
	       	         _stiva(_n-1,3) = err_rel;
       		         S = val - err_rel*val;
	                D = val + err_rel*val;
	                if S < D
                       _stiva(_n-1,4) = S;
	                       _stiva(_n-1,5) = D;
	                else
	       	                _stiva(_n-1,4) = D;
	                       _stiva(_n-1,5) = S;
	                end
	                _n = _n -1;
	                _stiva=_stiva(1:_n,:);
	                reset_view(_n,_stiva);
		else
			x_message(['warning: x1-x2 = 0. Formula erorii';'la scadere nu se poate aplica'],['Ok']);
		end
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
endfunction

function [_n,_stiva]=inmultire(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
		val = _stiva(_n-1,2)*_stiva(_n,2);
                err_rel = _stiva(_n-1,3) + _stiva(_n,3);
                _stiva(_n-1,2) = val;
                _stiva(_n-1,3) = err_rel;
                S = val - err_rel*val;
                D = val + err_rel*val;
                if S < D
                       _stiva(_n-1,4) = S;
                       _stiva(_n-1,5) = D;
                else
                       _stiva(_n-1,4) = D;
                       _stiva(_n-1,5) = S;
                end
                _n = _n -1;
                _stiva=_stiva(1:_n,:);
                reset_view(_n,_stiva);
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
endfunction
 
function [_n,_stiva]=impartire(n,stiva)
	_n = n;
        _stiva = stiva;
        if _n > 1 then
		if _stiva(_n,2) ~= 0 then
		 	val = _stiva(_n-1,2)/_stiva(_n,2);
                	err_rel = _stiva(_n-1,3) + _stiva(_n,3);
                	_stiva(_n-1,2) = val;
                	_stiva(_n-1,3) = err_rel;
                	S = val - err_rel*val;
                	D = val + err_rel*val;
                	if S < D
                       		_stiva(_n-1,4) = S;
                       		_stiva(_n-1,5) = D;
                	else
                       		_stiva(_n-1,4) = D;
                       		_stiva(_n-1,5) = S;
                	end
        	        _n = _n -1;
                	_stiva=_stiva(1:_n,:);
	                reset_view(_n,_stiva);
		else
			x_message(['Ultima valoare este nula!!!'],['Ok']);
		end;
        else
                x_message(['Stiva contine doar 1 element!!!'],['Ok']);
        end;
endfunction
       
